Index: /branches/2015/dev_merge_2015/NEMOGCM/NEMO/LIM_SRC_3/limthd.F90
===================================================================
--- /branches/2015/dev_merge_2015/NEMOGCM/NEMO/LIM_SRC_3/limthd.F90	(revision 6059)
+++ /branches/2015/dev_merge_2015/NEMOGCM/NEMO/LIM_SRC_3/limthd.F90	(revision 6060)
@@ -25,23 +25,24 @@
    USE sbc_oce        ! Surface boundary condition: ocean fields
    USE sbc_ice        ! Surface boundary condition: ice fields
-   USE thd_ice        ! LIM thermodynamic sea-ice variables
-   USE dom_ice        ! LIM sea-ice domain
+   USE dom_ice        ! LIM: sea-ice domain
+   USE thd_ice        ! LIM: thermodynamic sea-ice variables
    USE limthd_dif     ! LIM: thermodynamics, vertical diffusion
    USE limthd_dh      ! LIM: thermodynamics, ice and snow thickness variation
    USE limthd_sal     ! LIM: thermodynamics, ice salinity
    USE limthd_ent     ! LIM: thermodynamics, ice enthalpy redistribution
-   USE limthd_lac     ! LIM-3 lateral accretion
-   USE limitd_th      ! remapping thickness distribution
+   USE limthd_lac     ! LIM: lateral accretion
+   USE limitd_th      ! LIM: remapping thickness distribution
    USE limtab         ! LIM: 1D <==> 2D transformation
    USE limvar         ! LIM: sea-ice variables
+   USE limcons        ! LIM: conservation tests
+   USE limctl         ! LIM: control print
+   !
+   USE in_out_manager ! I/O manager
+   USE prtctl         ! Print control
    USE lbclnk         ! lateral boundary condition - MPP links
    USE lib_mpp        ! MPP library
    USE wrk_nemo       ! work arrays
-   USE in_out_manager ! I/O manager
-   USE prtctl         ! Print control
    USE lib_fortran    ! Fortran utilities (allows no signed zero when 'key_nosignedzero' defined)  
    USE timing         ! Timing
-   USE limcons        ! conservation tests
-   USE limctl
 
    IMPLICIT NONE
@@ -52,5 +53,4 @@
 
    !! * Substitutions
-#  include "domzgr_substitute.h90"
 #  include "vectopt_loop_substitute.h90"
    !!----------------------------------------------------------------------
@@ -81,19 +81,17 @@
       !!---------------------------------------------------------------------
       INTEGER, INTENT(in) :: kt    ! number of iteration
-      !!
+      !
       INTEGER  :: ji, jj, jk, jl   ! dummy loop indices
       INTEGER  :: nbpb             ! nb of icy pts for vertical thermo calculations
-      INTEGER  :: ii, ij           ! temporary dummy loop index
       REAL(wp) :: zfric_u, zqld, zqfr
       REAL(wp) :: zvi_b, zsmv_b, zei_b, zfs_b, zfw_b, zft_b 
       REAL(wp), PARAMETER :: zfric_umin = 0._wp           ! lower bound for the friction velocity (cice value=5.e-04)
       REAL(wp), PARAMETER :: zch        = 0.0057_wp       ! heat transfer coefficient
-      !
       !!-------------------------------------------------------------------
 
-      IF( nn_timing == 1 )  CALL timing_start('limthd')
+      IF( nn_timing == 1 )   CALL timing_start('limthd')
 
       ! conservation test
-      IF( ln_limdiahsb ) CALL lim_cons_hsm(0, 'limthd', zvi_b, zsmv_b, zei_b, zfw_b, zfs_b, zft_b)
+      IF( ln_limdiahsb )   CALL lim_cons_hsm( 0, 'limthd', zvi_b, zsmv_b, zei_b, zfw_b, zfs_b, zft_b )
 
       CALL lim_var_glo2eqv
@@ -147,5 +145,5 @@
 
             ! --- Energy needed to bring ocean surface layer until its freezing (<0, J.m-2) --- !
-            zqfr = tmask(ji,jj,1) * rau0 * rcp * fse3t_m(ji,jj) * ( t_bo(ji,jj) - ( sst_m(ji,jj) + rt0 ) )
+            zqfr = tmask(ji,jj,1) * rau0 * rcp * e3t_m(ji,jj) * ( t_bo(ji,jj) - ( sst_m(ji,jj) + rt0 ) )
 
             ! --- Energy from the turbulent oceanic heat flux (W/m2) --- !
@@ -226,47 +224,25 @@
 
          IF( nbpb > 0 ) THEN  ! If there is no ice, do nothing.
-
-            !-------------------------!
-            ! --- Move to 1D arrays ---
-            !-------------------------!
-            CALL lim_thd_1d2d( nbpb, jl, 1 )
-
-            !--------------------------------------!
-            ! --- Ice/Snow Temperature profile --- !
-            !--------------------------------------!
-            CALL lim_thd_dif( 1, nbpb )
-
-            !---------------------------------!
-            ! --- Ice/Snow thickness ---      !
-            !---------------------------------!
-            CALL lim_thd_dh( 1, nbpb )    
-
-            ! --- Ice enthalpy remapping --- !
-            CALL lim_thd_ent( 1, nbpb, q_i_1d(1:nbpb,:) ) 
-                                            
-            !---------------------------------!
-            ! --- Ice salinity ---            !
-            !---------------------------------!
-            CALL lim_thd_sal( 1, nbpb )    
-
-            !---------------------------------!
-            ! --- temperature update ---      !
-            !---------------------------------!
-            CALL lim_thd_temp( 1, nbpb )
-
-            !------------------------------------!
-            ! --- lateral melting if monocat --- !
-            !------------------------------------!
+            !
+            CALL lim_thd_1d2d( nbpb, jl, 1 )                ! --- Move to 1D arrays ---!
+            !
+            CALL lim_thd_dif ( 1, nbpb )                    ! --- Ice/Snow Temperature profile --- !
+            !
+            CALL lim_thd_dh  ( 1, nbpb )                    ! --- Ice/Snow thickness ---!
+            !
+            CALL lim_thd_ent ( 1, nbpb, q_i_1d(1:nbpb,:) )  ! --- Ice enthalpy remapping --- !
+            !
+            CALL lim_thd_sal ( 1, nbpb )                    ! --- Ice salinity ---            !
+            !
+            CALL lim_thd_temp( 1, nbpb )                    ! --- temperature update ---      !
+            !
+            !                                               ! --- lateral melting if monocat --- !
             IF ( ( nn_monocat == 1 .OR. nn_monocat == 4 ) .AND. jpl == 1 ) THEN
                CALL lim_thd_lam( 1, nbpb )
             END IF
-
-            !-------------------------!
-            ! --- Move to 2D arrays ---
-            !-------------------------!
-            CALL lim_thd_1d2d( nbpb, jl, 2 )
-
-            !
-            IF( lk_mpp )   CALL mpp_comm_free( ncomm_ice ) !RB necessary ??
+            !
+            CALL lim_thd_1d2d( nbpb, jl, 2 )                ! --- Move to 2D arrays ---
+            !
+            IF( lk_mpp )   CALL mpp_comm_free( ncomm_ice )  !RB necessary ??
          ENDIF
          !
@@ -410,6 +386,6 @@
       ENDIF
       !
-      IF( nn_timing == 1 )  CALL timing_stop('limthd')
-
+      IF( nn_timing == 1 )   CALL timing_stop('limthd')
+      !
    END SUBROUTINE lim_thd 
 
@@ -424,5 +400,5 @@
       !!-------------------------------------------------------------------
       INTEGER, INTENT(in) ::   kideb, kiut   ! bounds for the spatial loop
-      !!
+      !
       INTEGER  ::   ji, jk   ! dummy loop indices
       REAL(wp) ::   ztmelts, zaaa, zbbb, zccc, zdiscrim  ! local scalar 
@@ -444,6 +420,7 @@
          END DO 
       END DO 
-
+      !
    END SUBROUTINE lim_thd_temp
+
 
    SUBROUTINE lim_thd_lam( kideb, kiut )
@@ -455,9 +432,11 @@
       !!-----------------------------------------------------------------------
       INTEGER, INTENT(in) ::   kideb, kiut        ! bounds for the spatial loop
-      INTEGER             ::   ji                 ! dummy loop indices
-      REAL(wp)            ::   zhi_bef            ! ice thickness before thermo
-      REAL(wp)            ::   zdh_mel, zda_mel   ! net melting
-      REAL(wp)            ::   zvi, zvs           ! ice/snow volumes 
-
+      !
+      INTEGER  ::   ji                 ! dummy loop indices
+      REAL(wp) ::   zhi_bef            ! ice thickness before thermo
+      REAL(wp) ::   zdh_mel, zda_mel   ! net melting
+      REAL(wp) ::   zvi, zvs           ! ice/snow volumes 
+      !!-----------------------------------------------------------------------
+      !
       DO ji = kideb, kiut
          zdh_mel = MIN( 0._wp, dh_i_surf(ji) + dh_i_bott(ji) + dh_snowice(ji) )
@@ -477,6 +456,7 @@
          END IF
       END DO
-      
+      !
    END SUBROUTINE lim_thd_lam
+
 
    SUBROUTINE lim_thd_1d2d( nbpb, jl, kn )
@@ -486,19 +466,20 @@
       !! ** Purpose :   move arrays from 1d to 2d and the reverse
       !!-----------------------------------------------------------------------
-      INTEGER, INTENT(in) ::   kn       ! 1= from 2D to 1D
-                                        ! 2= from 1D to 2D
+      INTEGER, INTENT(in) ::   kn       ! 1= from 2D to 1D   ;   2= from 1D to 2D
       INTEGER, INTENT(in) ::   nbpb     ! size of 1D arrays
       INTEGER, INTENT(in) ::   jl       ! ice cat
+      !
       INTEGER             ::   jk       ! dummy loop indices
-
+      !!-----------------------------------------------------------------------
+      !
       SELECT CASE( kn )
-
-      CASE( 1 )
-
+      !
+      CASE( 1 )            ! from 2D to 1D
+         !
          CALL tab_2d_1d( nbpb, at_i_1d     (1:nbpb), at_i            , jpi, jpj, npb(1:nbpb) )
          CALL tab_2d_1d( nbpb, a_i_1d      (1:nbpb), a_i(:,:,jl)     , jpi, jpj, npb(1:nbpb) )
          CALL tab_2d_1d( nbpb, ht_i_1d     (1:nbpb), ht_i(:,:,jl)    , jpi, jpj, npb(1:nbpb) )
          CALL tab_2d_1d( nbpb, ht_s_1d     (1:nbpb), ht_s(:,:,jl)    , jpi, jpj, npb(1:nbpb) )
-         
+         !
          CALL tab_2d_1d( nbpb, t_su_1d     (1:nbpb), t_su(:,:,jl)    , jpi, jpj, npb(1:nbpb) )
          CALL tab_2d_1d( nbpb, sm_i_1d     (1:nbpb), sm_i(:,:,jl)    , jpi, jpj, npb(1:nbpb) )
@@ -512,5 +493,5 @@
             CALL tab_2d_1d( nbpb, s_i_1d(1:nbpb,jk), s_i(:,:,jk,jl)  , jpi, jpj, npb(1:nbpb) )
          END DO
-         
+         !
          CALL tab_2d_1d( nbpb, qprec_ice_1d(1:nbpb), qprec_ice(:,:) , jpi, jpj, npb(1:nbpb) )
          CALL tab_2d_1d( nbpb, qsr_ice_1d (1:nbpb), qsr_ice(:,:,jl) , jpi, jpj, npb(1:nbpb) )
@@ -526,8 +507,8 @@
          CALL tab_2d_1d( nbpb, qlead_1d   (1:nbpb), qlead           , jpi, jpj, npb(1:nbpb) )
          CALL tab_2d_1d( nbpb, fhld_1d    (1:nbpb), fhld            , jpi, jpj, npb(1:nbpb) )
-         
+         !
          CALL tab_2d_1d( nbpb, wfx_snw_1d (1:nbpb), wfx_snw         , jpi, jpj, npb(1:nbpb) )
          CALL tab_2d_1d( nbpb, wfx_sub_1d (1:nbpb), wfx_sub         , jpi, jpj, npb(1:nbpb) )
-         
+         !
          CALL tab_2d_1d( nbpb, wfx_bog_1d (1:nbpb), wfx_bog         , jpi, jpj, npb(1:nbpb) )
          CALL tab_2d_1d( nbpb, wfx_bom_1d (1:nbpb), wfx_bom         , jpi, jpj, npb(1:nbpb) )
@@ -536,5 +517,5 @@
          CALL tab_2d_1d( nbpb, wfx_res_1d (1:nbpb), wfx_res         , jpi, jpj, npb(1:nbpb) )
          CALL tab_2d_1d( nbpb, wfx_spr_1d (1:nbpb), wfx_spr         , jpi, jpj, npb(1:nbpb) )
-         
+         !
          CALL tab_2d_1d( nbpb, sfx_bog_1d (1:nbpb), sfx_bog         , jpi, jpj, npb(1:nbpb) )
          CALL tab_2d_1d( nbpb, sfx_bom_1d (1:nbpb), sfx_bom         , jpi, jpj, npb(1:nbpb) )
@@ -543,5 +524,5 @@
          CALL tab_2d_1d( nbpb, sfx_bri_1d (1:nbpb), sfx_bri         , jpi, jpj, npb(1:nbpb) )
          CALL tab_2d_1d( nbpb, sfx_res_1d (1:nbpb), sfx_res         , jpi, jpj, npb(1:nbpb) )
-         
+         !
          CALL tab_2d_1d( nbpb, hfx_thd_1d (1:nbpb), hfx_thd         , jpi, jpj, npb(1:nbpb) )
          CALL tab_2d_1d( nbpb, hfx_spr_1d (1:nbpb), hfx_spr         , jpi, jpj, npb(1:nbpb) )
@@ -557,7 +538,7 @@
          CALL tab_2d_1d( nbpb, hfx_err_dif_1d (1:nbpb), hfx_err_dif , jpi, jpj, npb(1:nbpb) )
          CALL tab_2d_1d( nbpb, hfx_err_rem_1d (1:nbpb), hfx_err_rem , jpi, jpj, npb(1:nbpb) )
-
-      CASE( 2 )
-
+         !
+      CASE( 2 )            ! from 1D to 2D
+         !
          CALL tab_1d_2d( nbpb, at_i          , npb, at_i_1d    (1:nbpb)   , jpi, jpj )
          CALL tab_1d_2d( nbpb, ht_i(:,:,jl)  , npb, ht_i_1d    (1:nbpb)   , jpi, jpj )
@@ -576,8 +557,8 @@
          END DO
          CALL tab_1d_2d( nbpb, qlead         , npb, qlead_1d  (1:nbpb)   , jpi, jpj )
-         
+         !
          CALL tab_1d_2d( nbpb, wfx_snw       , npb, wfx_snw_1d(1:nbpb)   , jpi, jpj )
          CALL tab_1d_2d( nbpb, wfx_sub       , npb, wfx_sub_1d(1:nbpb)   , jpi, jpj )
-         
+         !
          CALL tab_1d_2d( nbpb, wfx_bog       , npb, wfx_bog_1d(1:nbpb)   , jpi, jpj )
          CALL tab_1d_2d( nbpb, wfx_bom       , npb, wfx_bom_1d(1:nbpb)   , jpi, jpj )
@@ -586,5 +567,5 @@
          CALL tab_1d_2d( nbpb, wfx_res       , npb, wfx_res_1d(1:nbpb)   , jpi, jpj )
          CALL tab_1d_2d( nbpb, wfx_spr       , npb, wfx_spr_1d(1:nbpb)   , jpi, jpj )
-         
+         !
          CALL tab_1d_2d( nbpb, sfx_bog       , npb, sfx_bog_1d(1:nbpb)   , jpi, jpj )
          CALL tab_1d_2d( nbpb, sfx_bom       , npb, sfx_bom_1d(1:nbpb)   , jpi, jpj )
@@ -593,5 +574,5 @@
          CALL tab_1d_2d( nbpb, sfx_res       , npb, sfx_res_1d(1:nbpb)   , jpi, jpj )
          CALL tab_1d_2d( nbpb, sfx_bri       , npb, sfx_bri_1d(1:nbpb)   , jpi, jpj )
-         
+         !
          CALL tab_1d_2d( nbpb, hfx_thd       , npb, hfx_thd_1d(1:nbpb)   , jpi, jpj )
          CALL tab_1d_2d( nbpb, hfx_spr       , npb, hfx_spr_1d(1:nbpb)   , jpi, jpj )
@@ -612,5 +593,5 @@
          !         
       END SELECT
-
+      !
    END SUBROUTINE lim_thd_1d2d
 
@@ -629,6 +610,7 @@
       !!-------------------------------------------------------------------
       INTEGER  ::   ios                 ! Local integer output status for namelist read
-      NAMELIST/namicethd/ rn_hnewice, ln_frazil, rn_maxfrazb, rn_vfrazb, rn_Cfrazb,                       &
-         &                rn_himin, rn_betas, rn_kappa_i, nn_conv_dif, rn_terr_dif, nn_ice_thcon, &
+      !!
+      NAMELIST/namicethd/ rn_hnewice, ln_frazil, rn_maxfrazb, rn_vfrazb, rn_Cfrazb,                &
+         &                rn_himin, rn_betas, rn_kappa_i, nn_conv_dif, rn_terr_dif, nn_ice_thcon,  &
          &                nn_monocat, ln_it_qnsice
       !!-------------------------------------------------------------------
